
using Godot;
using System.Collections.Generic;

public class Issue : Spatial {
  Label fpsLabel;
  RandomNumberGenerator Rng = new RandomNumberGenerator();

  public override void _Ready() {
    fpsLabel = GetNode<Label>("/root/Spatial/Label");

    // set variables needed in static class
    Cubes.Scenario = GetWorld().Scenario;
    Cubes.Space = GetWorld().Space;

    // create 1 background thread
    // which processes job queue
    JobSystem.Create(1);
  }

  int id = 0;
  List<int> ids = new List<int>(1000);

  public override void _Process(float delta) {
    fpsLabel.Text = "FPS: " + Engine.GetFramesPerSecond().ToString();

    if (Rng.Randf() < 0.9f) {
      AddCubeJob job = new AddCubeJob();
      job.Id = id;
      ids.Add(job.Id);
      job.Size = new Vector3(Rng.RandfRange(1f, 5f), Rng.RandfRange(1f, 5f), Rng.RandfRange(1f, 5f));
      job.Position = new Transform(Basis.Identity, new Vector3(Rng.RandfRange(-200f, 200f), 0f, Rng.RandfRange(-100f, 100f)));
      JobSystem.Enqueue(job);

      id += 1;
    }

    if ((Rng.Randf() < 0.5f && ids.Count > 1) || ids.Count > 1000) {
      RemoveCubeJob job = new RemoveCubeJob();
      int random = Rng.RandiRange(0, ids.Count - 2);
      job.Id = ids[random];
      ids.RemoveAt(random);
      JobSystem.Enqueue(job);
    }
  }
}

// jobs
public struct AddCubeJob : IJob {
  public int Id;
  public Vector3 Size;
  public Transform Position;

  public void Execute() {
    Cubes.Add(Id, Size, Position);
  }
}

public struct RemoveCubeJob : IJob {
  public int Id;

  public void Execute() {
    Cubes.Remove(Id);
  }
}