
using System.Collections.Concurrent;
using System.Threading;

public interface IJob {
  public void Execute();
}

public static class JobSystem {
  static BlockingCollection<object> jobs = new BlockingCollection<object>();

  public static void Create(int numOfThreads = 1) {
    for (int i = 0; i < numOfThreads; i++) {        
      Thread thread = new Thread(OnStart);
      thread.IsBackground = true;
      thread.Start();
    }
  }
 
  public static void Enqueue(IJob job) {
    jobs.Add(job);
  }

  static void OnStart() {
    foreach (IJob job in jobs.GetConsumingEnumerable(CancellationToken.None)) {
      job.Execute();
    }
  }
}